<!DOCTYPE html>
<html lang="en">

<head>
	<meta charset="UTF-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<meta http-equiv="X-UA-Compatible" content="ie=edge">
	<title>dz-adv-2</title>
</head>

<body>
	<script>
		class Hamburger {
			constructor(size, stuffing) {
				this._size = size;
				this._stuffing = stuffing;
				this.addToppings = [];
			}
			check() {
				try {
					if (arguments.length !== 2) {
						throw new HamburgerException("Вы должны выбрать как минимум два ингредиента !");
					} else if (size !== Hamburger.SIZE_SMALL && size !== Hamburger.SIZE_LARGE) {
						throw new HamburgerException("Извините, доступны только небольшие размеры !");
					} else if (stuffing !== Hamburger.STUFFING_CHEESE && stuffing !== Hamburger.STUFFING_POTATO && stuffing !== Hamburger.STUFFING_SALAD) {
						throw new HamburgerException("Пожалуйста, введите правильную начинку: сыр, салат или картофель !");
					}
				} catch (error) {
					console.log(error.message);
				}
			}
			addTopping(topping) {
				if (!topping) {
					throw new HamburgerException("Без начинки !");
				} else if (this.addToppings.includes(topping)) {
					throw new HamburgerException("Вы уже выбрали эту начинку !");
				} else if (topping.type !== "topping") {
					throw new HamburgerException("Введите правильное название начинки !");
				}
				else {
					this.addToppings.push(topping);
				}
			}
			removeTopping(topping) {
				if (!topping) {
					throw new HamburgerException("removing topping is underfined");
				} else if (this.addToppings.length == 0) {
					throw new HamburgerException("no toppings removing");
				}
				else {
					if (this.addToppings.indexOf(topping) !== -1) {
						return this.addToppings.splice(this.addToppings.indexOf(topping), 1);
					} else {
						throw new HamburgerException("no toppings");
					}
				}
			}
			getToppings() {
				return this.addToppings
			}
			
			getSize() {
				return this._size;
			}
			getStuffing() {
				return this._stuffing.type;
			}
			calculatePrice() {
				let toppingPrice = 0;

				if(this.addToppings.length > 0) {
					this.addToppings.forEach(item => {
						toppingPrice += item.price;
					})
				}
				return this._size.price + this._stuffing.price + toppingPrice;
			}
			calculateCalories() {
				let toppingKlkal = 0;

				if(this.addToppings.length > 0) {
					this.addToppings.forEach(item => {
						toppingKlkal += item.kkal;
					})
				}
				return this._size.kkal + this._stuffing.kkal + toppingKlkal;_
			}
		}
		Hamburger.SIZE_SMALL = {
			price: 50,
			kkal: 20,
			type: "small",
		};
		Hamburger.SIZE_LARGE = {
			price: 100,
			kkal: 40,
			type: "large",
		};
		Hamburger.STUFFING_CHEESE = {
			price: 10,
			kkal: 20,
			type: "cheese",
		};
		Hamburger.STUFFING_SALAD = {
			price: 20,
			kkal: 5,
			type: "salado"
		};
		Hamburger.STUFFING_POTATO = {
			price: 15,
			kkal: 10,
			type: "potato",
		};
		Hamburger.TOPPING_MAYO = {
			price: 20,
			kkal: 5,
			type: "topping",
		};
		Hamburger.TOPPING_SPICE = {
			price: 15,
			kkal: 0,
			type: "topping",
		};

		try {
			let hamburger = new Hamburger(Hamburger.SIZE_SMALL, Hamburger.STUFFING_CHEESE);
			

          // добавка из майонеза
          hamburger.addTopping(Hamburger.TOPPING_MAYO);
          console.log(hamburger);
          console.log("Have %d toppings", hamburger.getToppings().length);

          // спросим сколько там калорий
          console.log("Calories: %f", hamburger.calculateCalories());

          // сколько стоит
          console.log("Price: %f", hamburger.calculatePrice(), "UAH");

          // я тут передумал и решил добавить еще приправ
          hamburger.addTopping(Hamburger.TOPPING_SPICE);
          console.log("Have %d toppings", hamburger.getToppings().length);

          // А сколько теперь стоит? 
          console.log("Price with sauce: %f", hamburger.calculatePrice());

          // Проверить, большой ли гамбургер? 
          console.log("Is hamburger large: %s", hamburger.getSize() === Hamburger.SIZE_LARGE);

          console.log(hamburger.getStuffing());
          
          
      } catch (error) {
      	console.log(error.message);
      }

      function HamburgerException(message) {
      	this.name = 'Error',
      	this.message = message;
      }
  </script>
</body>

</html>
